/*
Copyright 2021 The Hybridnet Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	multiclusterv1 "github.com/alibaba/hybridnet/pkg/apis/multicluster/v1"
	versioned "github.com/alibaba/hybridnet/pkg/client/clientset/versioned"
	internalinterfaces "github.com/alibaba/hybridnet/pkg/client/informers/externalversions/internalinterfaces"
	v1 "github.com/alibaba/hybridnet/pkg/client/listers/multicluster/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// RemoteVtepInformer provides access to a shared informer and lister for
// RemoteVteps.
type RemoteVtepInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.RemoteVtepLister
}

type remoteVtepInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewRemoteVtepInformer constructs a new informer for RemoteVtep type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewRemoteVtepInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredRemoteVtepInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredRemoteVtepInformer constructs a new informer for RemoteVtep type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredRemoteVtepInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.MulticlusterV1().RemoteVteps().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.MulticlusterV1().RemoteVteps().Watch(context.TODO(), options)
			},
		},
		&multiclusterv1.RemoteVtep{},
		resyncPeriod,
		indexers,
	)
}

func (f *remoteVtepInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredRemoteVtepInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *remoteVtepInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&multiclusterv1.RemoteVtep{}, f.defaultInformer)
}

func (f *remoteVtepInformer) Lister() v1.RemoteVtepLister {
	return v1.NewRemoteVtepLister(f.Informer().GetIndexer())
}
